#include <stdlib.h>
#include <string.h>

#if !defined(LINUX)
  #include <conio.h>
  #include <io.h>
  #include <dos.h>
  #include <sys\stat.h>  
#else
  #include <stdio.h>
  #include <unistd.h>
  #define O_BINARY 0
  #define O_TEXT 0
  #define putch putchar
#endif
  
#include <fcntl.h>

#include "stdcon.h"

#if defined(__MSDOS__)
  #include <bios.h>
#endif

#if defined(LINUX)
  inline char* ltoa(int x, char *buf, int radicle){
    sprintf(buf, "%d", x);
    return buf;  
  }
  inline char* itoa(int x, char *buf, int radicle){
    sprintf(buf, "%d", x);
    return buf;    
  }    
#endif

TLogOutput StdLog, VerboseLog;
TConOutput Console;
TDosOutput DosCon;
int ScreenLines=25;

//TOutput& TOutput::operator<<(const char* s){
//  for(;*s; s++) *this<<*s;
//  return *this;
//}

TOutput& TOutput::operator<<(int x){
  char buf[16];
  return *this<<itoa(x, buf, 10);
}

TOutput& TOutput::operator<<(long l){
  char buf[16];
  return *this<<ltoa(l, buf, 10);
}

/********************************************************** TScreenOutput ***/

TOutput& TScreenOutput::More(const char* s){
  unsigned linecount=1, i=0;
  int pause_flag=0;
  while(s[i]!=0){
    (*this)<<s[i];
    if(!LockScreen && s[i++]=='\n')
      if(!((linecount++)%(ScreenLines-2))){ KeypPause(); pause_flag=1; }
      else pause_flag=0;
  };
  if(!pause_flag) KeypPause();
  return *this;
}

/********************************************************** TLogOutput ******/

const char ERR_LO_FAO[]="Log file already opened in TLogOutput::";

int TLogOutput::AppendFile(const char* s){
  if(Handle>=0) ExitProgram(ecFileOpenBug, ERR_LO_FAO, "AppendFile().\n", NULL);
  Handle=open(s, O_RDWR|O_APPEND|O_CREAT|O_TEXT);
  strcpy(FileName, s);
//  if(Handle<0){ 
//    Handle=open(s, O_APPEND|O_TEXT);
//    if(Handle>=0) lseek(Handle, filelength(Handle), SEEK_SET); 
//  }
  return !(Handle>=0);
}

int TLogOutput::OverwriteFile(const char* s){
  if(Handle>=0) ExitProgram(ecFileOpenBug, ERR_LO_FAO, "OverwriteFile().\n", NULL);
  Handle=open(s, O_RDWR|O_TRUNC|O_CREAT|O_TEXT);
  strcpy(FileName, s);
  return !(Handle>=0);
}

int TLogOutput::CloseFile(){
  if(Handle>=0){ 
    #if defined(__GNUC__)
      chmod(FileName, S_IREAD|S_IWRITE);
    #endif
    return close(Handle); 
  }else 
    return 0;
}

//*** 㭪樨 뢮
TOutput& TLogOutput::operator<<(char c){
  if(!LockScreen){
    if(c=='\n'){ putch('\r'); putch('\n'); } else putch(c); };
  if(Handle>=0) write(Handle, &c, 1);
  return *this;
}

TOutput& TLogOutput::operator<<(const char* s){
  if(!LockScreen)
    for(const char* s2=s; *s2; s2++)
      if(*s2=='\n'){ putch('\r'); putch('\n'); } else putch(*s2);
  if(Handle>=0) write(Handle, s, strlen(s));
  return *this;
}

/************************************************************* TConOutput ***/

TOutput& TConOutput::operator<<(char c){
  if(!LockScreen)
    if(c=='\n'){ putch('\r'); putch('\n'); }
    else putch(c);
  return *this;
}

TOutput& TConOutput::operator<<(const char* s){
  if(!LockScreen) for(; *s; s++) *this<<char(*s);
  return *this;
}

/************************************************************* TDosOutput ***/

TOutput& TDosOutput::operator<<(char c){
  putchar(c);
  return *this;
}

TOutput& TDosOutput::operator<<(const char* s){
  printf("%s", s);
  return *this;
}

const char* Fmt10(long x, int w, int fill){
  static char buf[16], retbuf[32];
  if((w>0) && (w<30)){
    if(fill) sprintf(buf, "%%%c%dl", fill, w);
    else     sprintf(buf, "%%%dl", w);
    sprintf(retbuf, buf, x);
    return retbuf; }
  else return ltoa(x, retbuf, 10);
}

const char* Fmt16(long x, int w, int fill){
  static char buf[16], retbuf[32];
  if((w>0) && (w<30)){
    if(fill) sprintf(buf, "%%%c%dlX", fill, w);
    else     sprintf(buf, "%%%dlX", w);
    sprintf(retbuf, buf, x);
    return retbuf; }
  else return ltoa(x, retbuf, 10);
}

const char* FmtDate(int d, int m, int y){
  static char buf[16];
  sprintf(buf, "%02d/%02d/%d", d, m, y);
  return buf;
}

const char* FmtTime(int h, int m, int s){
  static char buf[16];
  sprintf(buf, "%02d:%02d:%02d", h, m, s);
  return buf;
}

void Clocks(){
  static int cnt=0;
  const char c[5]="|/-\\";
  if(cnt==4) cnt=0;
//  Console<<c[cnt++]<<char(8);
  putch(c[cnt++]);
  putch('\r');
}

int KeypPause(){
  int ret;
  Console<<"    த...\r";
  #if defined(__MSDOS__)
    ret=bioskey(0);
  #else
    ret=getchar();
  #endif  
  Console<<"                                        \r";
  return ret;
}

const char* GetEnd_A_OV(long x){
  int l2=int(x%100);
  if(l2>10 && l2<20) return "";
  else
    switch(x%10){
      case 1: return "";
      case 2: case 3: case 4: return "";
      default: return ""; };
}

const char* GetEnd_A(long x){
  switch(x%10){
    case 2: case 3: case 4: return "";
    default: return ""; };
}

const char* GetEndKA_KI_OK(long x){
  int l2=int(x%100);
  if(l2>10 && l2<20) return "";
  else
    switch(x%10){
      case 1: return "";
      case 2: case 3: case 4: return "";
      default: return ""; };
}

