#if !defined(STDCON_H)
#define STDCON_H

#include <stdio.h>
#include <stdlib.h>

#if !defined(LINUX)
  #include <conio.h>
#else
  #include <dirent.h>  
  #define MAX_PATH NAME_MAX
#endif
  
#include <fcntl.h>
#include "common.h"

class TOutput{
  public:
    virtual TOutput& operator<<(char c)=0;
    virtual TOutput& operator<<(const char* s)=0;
    virtual TOutput& operator<<(int x);
    virtual TOutput& operator<<(long l);
};
ClassDefs(TOutput);

class TScreenOutput: public TOutput{
  protected:
    int LockScreen;
  public:
    TScreenOutput(){ LockScreen=0; }
    void ScreenMode    (int x){ LockScreen=!x; }
    int  GetScreenMode (){ return !LockScreen; }
    virtual TOutput& More(const char* s);
};
ClassDefs(TScreenOutput);

class TLogOutput: public TScreenOutput{
  protected:
    char FileName[MAX_PATH];
    int Handle;
  public:
    TLogOutput(){ Handle=-1; FileName[0]=0; }
    int  AppendFile    (const char* s); // 뢠 䠩  
    int  OverwriteFile (const char* s); // १뢠/ᮧ 䠩
    int  CloseFile     ();
    void AssignFile    (int h){ CloseFile(); Handle=h; }
    int  GetFileHandle (){ return Handle; }
    virtual TOutput& operator<<(char c);
    virtual TOutput& operator<<(const char* s);
    ~TLogOutput(){ CloseFile(); }
};
ClassDefs(TLogOutput);

class TConOutput: public TScreenOutput{
//  int Handle;
  public:
    virtual TOutput& operator<<(char c);
    virtual TOutput& operator<<(const char* s);
};
ClassDefs(TConOutput);

class TDosOutput: public TOutput{
  int Handle;
  public:
    virtual TOutput& operator<<(char c);
    virtual TOutput& operator<<(const char* s);
};
ClassDefs(TDosOutput);

extern TLogOutput StdLog, VerboseLog;
extern TConOutput Console;
extern TDosOutput DosCon;

const char endl='\n';

void Clocks();
int  KeypPause();
inline const char* GetYNR(int x) {return (x)?"":""; }

// ॢ ᫠  ⥪⮢ ப  ଠ஢
const char* Fmt10(long x, int w=0, int fill=0);
const char* Fmt16(long x, int w=0, int fill=0);
const char* FmtDate(int d, int m, int y);
const char* FmtTime(int h, int m, int s);

// 砭 ᫮, ᫥  ᫨⥫묨
const char* GetEnd_A_OV(long x); // ࠣ/ࠣ/ࠣ⮢
const char* GetEnd_A(long x);
const char* GetEndKA_KI_OK(long x);

#endif

